#Compile                 Exe  "dllHost1.exe"
'%DEBUG                  = 1
%UNICODE                 = 1
#Include                 "Win32api.inc"
%IDC_GRID1               = 1500
%IDC_RETRIEVE            = 1600
%IDC_SET_ROW_COUNT       = 1605
%GRID_CELL_CHAR          = 40000
%GRID_CELL_KEYDOWN       = 40001
%GRID_CELL_LBUTTONDOWN   = 40002
%GRID_CELL_LBUTTONDBLCLK = 40003
%GRID_CELL_PASTE         = 40004
%GRID_VBUTTON_CLICK      = 40005

#If %Def(%UNICODE)
    Macro ZStr           = WStringz
    Macro BStr           = WString
    %SIZEOF_CHAR         = 2
#Else
    Macro ZStr           = Asciiz
    Macro BStr           = String
    %SIZEOF_CHAR         = 1
#EndIf

Type WndEventArgs
  wParam                 As Long
  lParam                 As Long
  hWnd                   As Dword
  hInst                  As Dword
End Type

Declare Function FnPtr(wea As WndEventArgs) As Long

Type MessageHandler
  wMessage               As Long
  dwFnPtr                As Dword
End Type
Global MsgHdlr()         As MessageHandler

#If %Def(%DEBUG)
Global fp                As Long
#EndIf

Type GridData
  iCtrlID                As Long       'Control ID of Grid
  hParent                As Dword      'Handle To Grid's Parent, i.e., the object whose CreateWindow() Call Created The Grid.
  hGrid                  As Dword      'Handle To Grid
  hBase                  As Dword      'Parent of Pane.  Needed to solve intractable Z Order problem with Verticle Buttons
  hPane                  As Dword      'The Pane Is A Child Of The Grid.  It Is What The Cells Are Painted On.  hPane Is The Handle
  hEdit                  As Dword      'Handle of edit control.  May be NULL if not existing.  Its what you type into.
  cx                     As Dword      'This Would Be The Width Of The Grid From The CreateWindow() Call That Created It.
  cy                     As Dword      'This Would Be The Height Of The Grid From The CreateWindow() Call That Created It.
  hHeader                As Dword      'Handle Of Header Common Control That Allows For Resizable Columns.
  iCols                  As Dword      'Number Of Colums In Grid.  This Is Determined From A ParseCount Of strSetup.
  iRows                  As Dword      'This Is The Number Of Rows Of Data The Grid Will Hold, Which Can Be Many More Than the Visible Rows.
  iVisibleRows           As Dword      'This Is How Many Rows Are Visible, Given How Large The Grid Is Top To Bottom from cx and cy
  iRowHeight             As Dword      'How Many Pixels High Each Row Is.  This affects how many rows are visible.
  iPaneHeight            As Dword      'A bit complicated.  Will explain in WM_CREATE handler.
  iEditedCellRow         As Long       'This number will be between 1 and iVisibleRows.
  iEditedRow             As Long       'This will be the row number in the underlying data buffer
  iEditedCol             As Long       'Column where editing is taking place
  pColWidths             As Dword Ptr  'Allocated in WM_CREATE.  Contains the present column widths. Zero based, i.e., col 1 in zero, etc.
  pCellHandles           As Dword Ptr  'Allocated in WM_CREATE for grid.  Stores Cell handles.
  pGridMemory            As Dword Ptr  'Allocated when # of rows are known, i.e., in WM_CREATE.  Holds pointers to ZStrs.
  pVButtons              As Dword Ptr  'Same as above.  Holds handles of verticle buttons along left edge of grid
  blnAddNew              As Long       'Not used at this time.  Will be used if new rows can be added.
  iFontSize              As Long       'Self explanatory
  iFontWeight            As Long       'For CreateFont() call
  hFont                  As Dword      'Handle to Font.
  szFontName             As ZStr * 28  'Self explanatory
End Type

Type dllGridMessage
  lpnmh                  As NMHDR
  ptCell                 As Points
  iCol                   As Long
  iRow                   As Long
  wParam                 As Long
  lParam                 As Long
End Type

Declare Function SetRowCount         Import "dllGrid.dll" Alias "SETROWCOUNT"         (Byval hGrid As Long, Byval iRowCount As Long, Byval blnForce As Long              ) As Long
Declare Function SetGrid             Import "dllGrid.dll" Alias "SETGRID"             (Byval hGrid As Long, Byval iRow As Long, Byval iCol As Long, Byval strData As BStr) As Long
Declare Function GetGrid             Import "dllGrid.dll" Alias "GETGRID"             (Byval hGrid As Long, Byval iRow As Long, Byval iCol As Long                       ) As BStr
Declare Function Initialize          Import "dllGrid.dll" Alias "INITIALIZE"          (                                                                                  ) As Long
Declare Function blnFlushEditControl Import "dllGrid.dll" Alias "BLNFLUSHEDITCONTROL" (Byval hGrid As Dword                                                              ) As Long
Declare Sub      Refresh             Import "dllGrid.dll" Alias "REFRESH"             (Byval hGrid As Dword                                                              )


Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local pCreateStruct As CREATESTRUCT Ptr
  Local hDll,hGrid,hBtn,dwStyle As Dword
  Local strSetup,strCoordinate As BStr
  Local grdData As GridData
  Register i As Long
  Register j As Long

  #If %Def(%DEBUG)
  fp=Freefile : Open "Output.txt" For Output As #fp
  Print #fp, "Entering fnWndProc_OnCreate()"
  #EndIf
  pCreateStruct=wea.lParam
  wea.hInst=@pCreateStruct.hInstance
  #If %Def(%DEBUG)
  Print #fp, "  Wea.hInst            = " Wea.hInst
  #EndIf
  Call Initialize()
  strSetup            = "120:Column 1:^," & _      '# pixels width of column : string caption of column : left, center, or right justified (not implemented yet).
                        "130:Column 2:^," & _
                        "140:Column 3:^," & _
                        "150:Column 4:^," & _
                        "160:Column 5:^"
  grdData.iCols       = 5
  grdData.iRowHeight  = 28
  grdData.szFontName  = "Times New Roman"
  grdData.iFontSize   = 18
  grdData.iFontWeight = %FW_DONTCARE
  grdData.iRows       = 50
  'FW_DONTCARE        0       'Font Weights from CreateFont()
  'FW_THIN            100
  'FW_EXTRALIGHT      200
  'FW_ULTRALIGHT      200
  'FW_LIGHT           300
  'FW_NORMAL          400
  'FW_REGULAR         400
  'FW_MEDIUM          500
  'FW_SEMIBOLD        600
  'FW_DEMIBOLD        600
  'FW_BOLD            700
  'FW_EXTRABOLD       800
  'FW_ULTRABOLD       800
  'FW_HEAVY           900
  'FW_BLACK           900
  #If %Def(%DEBUG)
  Print #fp, "  Varptr(grdData)      = " Varptr(grdData)
  #EndIf
  dwStyle=%WS_CHILD Or %WS_VISIBLE Or %WS_HSCROLL Or %WS_VSCROLL
  hGrid=CreateWindowEx(%WS_EX_OVERLAPPEDWINDOW,"Grid",Byval Strptr(strSetup),dwStyle,10,10,570,218,Wea.hWnd,%IDC_GRID1,Wea.hInst,ByVal Varptr(grdData))
  hBtn=CreateWindowEx(0,"button","Retrieve Cell (3, 2)",%WS_CHILD Or %WS_VISIBLE,75,235,150,30,Wea.hWnd,%IDC_RETRIEVE,Wea.hInst,Byval 0)
  hBtn=CreateWindowEx(0,"button","Test SetRowCount()",%WS_CHILD Or %WS_VISIBLE,350,235,150,30,Wea.hWnd,%IDC_SET_ROW_COUNT,Wea.hInst,Byval 0)
  If hGrid Then
     #If %Def(%DEBUG)
     Print #fp, "  hGrid                = " hGrid
     Print #fp, "  grdData.iVisibleRows = " grdData.iVisibleRows
     #EndIf
     Call SetWindowLong(Wea.hWnd,0,hGrid)
     For i=1 To grdData.iRows
       For j=1 To grdData.iCols
         strCoordinate=Trim$(Str$(i)) & "," & Trim$(Str$(j))
         Call SetGrid(hGrid,i,j,strCoordinate)
       Next j
     Next i
     Call Refresh(hGrid)
  Else
     #If %Def(%DEBUG)
     Print #fp, "  Grid Creation Failed!"
     #EndIf
  End If
  #If %Def(%DEBUG)
  Print #fp, "Leaving fnWndProc_OnCreate()"
  Print #fp,
  #EndIf

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnCommand(Wea As WndEventArgs) As Long
  Local strSetup,strCoordinate,strCell As BStr
  Local iNewRowCount,iReturn As Long
  Local hGrid As Dword
  Register i As Long
  Register j As Long

  #If %Def(%DEBUG)
  Print #fp, "Entering fnWndProc_OnCommand()"
  #EndIf
  hGrid=GetWindowLong(Wea.hWnd,0)
  If hGrid Then
     Select Case As Long Lowrd(Wea.wParam)
       Case %IDC_RETRIEVE
         Call blnFlushEditControl(hGrid)
         strCell=GetGrid(hGrid,3,2)
         MsgBox("Row 3, Col 2  (3, 2) Contains: " & strCell)
       Case %IDC_SET_ROW_COUNT
         If hGrid Then
            #If %Def(%DEBUG)
            Print #fp, "  hGrid                = " hGrid
            #EndIf
            iNewRowCount=15
            iReturn=SetRowCount(hGrid,iNewRowCount,1)
            #If %Def(%DEBUG)
            Print #fp, "  iReturn              = " iReturn
            #EndIf
            If iReturn Then
               For i=1 To iNewRowCount
                 For j=1 To 5
                   strCoordinate=Trim$(Str$(i)) & "," & Trim$(Str$(j))
                   Call SetGrid(hGrid,i,j,strCoordinate)
                 Next j
               Next i
               Call Refresh(hGrid)
            End If
         End If
     End Select
  End If
  #If %Def(%DEBUG)
  Print #fp, "Leaving fnWndProc_OnCommand()"
  Print #fp,
  #EndIf

  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnNotify(Wea As WndEventArgs) As Long
  Local dgm As dllGridMessage Ptr
  Local hGrid As Dword

  #If %Def(%DEBUG)
  Print #fp, "Entering fnWndProc_OnNotify()"
  #EndIf
  hGrid=GetWindowLong(Wea.hWnd,0)
  dgm=Wea.lParam
  Select Case As Long @dgm.lpnmh.idFrom
    Case %IDC_GRID1
      Select Case As Long @dgm.lpnmh.code
        Case %GRID_CELL_KEYDOWN
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_CELL_KEYDOWN"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "  Chr$$(@dgm.wParam)   = " Chr$$(@dgm.wParam)
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
        Case %GRID_CELL_CHAR
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_CELL_CHAR"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "  Chr$$(@dgm.wParam)   = " Chr$$(@dgm.wParam)
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
        Case %GRID_CELL_LBUTTONDOWN
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_CELL_LBUTTONDOWN"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "  Chr$$(@dgm.wParam)   = " Chr$$(@dgm.wParam)
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
        Case %GRID_CELL_LBUTTONDBLCLK
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_CELL_LBUTTONDBLCLK"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "  Chr$$(@dgm.wParam)   = " Chr$$(@dgm.wParam)
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
        Case %GRID_CELL_PASTE
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_CELL_PASTE"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "  Chr$$(@dgm.wParam)   = " Chr$$(@dgm.wParam)
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
        Case %GRID_VBUTTON_CLICK
          #If %Def(%DEBUG)
          Print #fp, "  %GRID_VBUTTON_CLICK"
          Print #fp, "  hGrid                = " hGrid
          Print #fp, "  Wea.lParam           = " Wea.lParam
          Print #fp, "  @dgm.ptCell.x        = " @dgm.ptCell.x
          Print #fp, "  @dgm.ptCell.y        = " @dgm.ptCell.y
          Print #fp, "  @dgm.iCol            = " @dgm.iCol
          Print #fp, "  @dgm.iRow            = " @dgm.iRow
          Print #fp, "  @dgm.lpnmh.idFrom    = " @dgm.lpnmh.idFrom
          Print #fp, "  @dgm.lpnmh.code      = " @dgm.lpnmh.code
          Print #fp, "  @dgm.lpnmh.hwndFrom  = " @dgm.lpnmh.hwndFrom
          Print #fp, "  @dgm.wParam          = " @dgm.wParam
          Print #fp, "Leaving fnWndProc_OnNotify()"
          Print #fp,
          #EndIf
      End Select
  End Select

  fnWndProc_OnNotify=0
End Function


Function fnWndProc_OnClose(Wea As WndEventArgs) As Long
  Local hGrid As Dword

  #If %Def(%DEBUG)
  Print #fp, "Entering fnWndProc_OnClose()"
  #EndIf
  hGrid=GetWindowLong(Wea.hWnd,0)
  If hGrid Then
     #If %Def(%DEBUG)
     Print #fp, "  hGrid                = " hGrid
     #EndIf
     Call SendMessage(hGrid,%WM_CLOSE,0,0)
  End If
  Call DestroyWindow(Wea.hWnd)
  Call PostQuitMessage(0)
  #If %Def(%DEBUG)
  Print #fp, "Leaving fnWndProc_OnClose()"
  Print #fp,
  Close #fp
  #EndIf

  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 3
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Sub AttachMessageHandlers()
  ReDim MsgHdlr(3) As MessageHandler   'Associate Windows Message With Message Handlers
  MsgHdlr(0).wMessage=%WM_CREATE   :   MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_COMMAND  :   MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnCommand)
  MsgHdlr(2).wMessage=%WM_NOTIFY   :   MsgHdlr(2).dwFnPtr=CodePtr(fnWndProc_OnNotify)
  MsgHdlr(3).wMessage=%WM_CLOSE    :   MsgHdlr(3).dwFnPtr=CodePtr(fnWndProc_OnClose)
End Sub


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local szAppName As ZStr*16
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  Call AttachMessageHandlers()                               : szAppName="dllHost1"
  wc.lpszClassName=VarPtr(szAppName)                         : wc.lpfnWndProc=CodePtr(fnWndProc)
  wc.cbSize=SizeOf(wc)                                       : wc.style=%CS_HREDRAW Or %CS_VREDRAW
  wc.cbClsExtra=0                                            : wc.cbWndExtra=4
  wc.hInstance=hIns                                          : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)             : wc.hbrBackground=%COLOR_BTNFACE+1
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)
  hWnd=CreateWindow(szAppName,"dllHost",%WS_OVERLAPPEDWINDOW,200,100,600,315,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
